/*     Chump
 *     Copyright 2002 Charles Brej
 *
 *     Chump is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as
 *     published by the Free Software Foundation; either version 2 of
 *     the License, or(at your option) any later version.
 * 
 *     Chump is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 * 
 *     You should have received a copy of the GNU Lesser General Public
 *     License along with chump; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
    
#ifndef CHUMP_H
#define CHUMP_H

#include <glib.h>

#define uchar unsigned char

#define DEFINITIONSTRING "define"
#define INTIGERSTRING "int"
#define RELATIVESTRING "relative"
#define UINTIGERSTRING "uint"
#define URELATIVESTRING "urelative"


typedef enum {NONTERM, TERM, TERM2FREE, NONTERM2FREE} RuleElementType;
typedef enum {TRANRULE, INTRULE, RELATIVERULE, UINTRULE, URELATIVERULE} RuleType;


typedef struct DefinitionStackName{
 struct DefinitionStackName* next;
 char* string;
 GList* rules;
 } DefinitionStack;

typedef struct {
 char* string;
 RuleElementType type; 
 int twin;
 GList* rules;
 } RuleElement;

typedef struct {
 RuleType type;
 GList* asci;
 GList* bit;
 } Rule;

typedef struct {
 GList* distext;
 GList* bitfield;
} Disasm;

typedef struct {
 GList* binary;
 char*  text;
 GList* ruletext;
} Asm;

GList dis_error;



DefinitionStack* asm_parser (GList*);
DefinitionStack* asm_define (GList*, DefinitionStack*, char*);
Rule* 			 asm_rule   (GList*, DefinitionStack*);
Disasm asm_disassemble(GList* bitfield,GList* rules,int);
GList* asm_assemble(char*,GList* rules,int,int);
Asm asm_assembleold(char*,GList* rules,int,int,int);
GList* uchararr2glist(int, uchar*);
void asm_print(GList*);
char* asm_sprint (GList* list, char*);
void asm_freestringlist(GList*);
GList* asm_copystringlist(GList*);
char* asm_sprint_tabstring (char*,char*);
int asm_sbprint (GList* list, uchar** data);
#endif
